//
//  RecipesAppDelegate.m
//  Recipes
//
//  Created by bill on 6/5/08.
//  Copyright __MyCompanyName__ 2008. All rights reserved.
//

#import "RecipesViewController.h"
#import "RecipesAppDelegate.h"
#import "AddRecipesViewController.h"

@implementation RecipesViewController

- (IBAction)edit:(id)sender {
	[self presentModalViewController:addRecipeController animated:YES];
}

- (void)addNewRecipeNamed:(NSString *)recipeName {
	[appDelegate addNewRecipeNamed:recipeName];
	[tableView reloadData];
}

- (void)removeIngredient:(NSString *)ingredient forRecipe:(NSString *)recipe {
	[appDelegate removeIngredient:ingredient forRecipe:recipe];
}

- (void)addIngredient:(NSString *)ingredient forRecipe:(NSString *)recipe {
	[appDelegate addIngredient:ingredient forRecipe:recipe];
}

- (void)displayAddNewIngredientScreen:(NSString *)recipeName {
	[appDelegate displayAddNewIngredientScreen:recipeName];
}

- (void) moveIngredientForRecipe:(NSString *)recipeName atIndex:(NSInteger)fromIndex toIndex:(NSInteger)toIndex {
	[appDelegate moveIngredientForRecipe:recipeName atIndex:fromIndex toIndex:toIndex];
}

- (UITableViewCell *)tableView:(UITableView *)tv cellForRowAtIndexPath:(NSIndexPath *)indexPath {
	UITableViewCell *cell = [tableView dequeueReusableCellWithIdentifier:@"recipeCell"];
	if(nil == cell) {
		cell = [[[UITableViewCell alloc] initWithFrame:CGRectZero reuseIdentifier:@"recipeCell"] autorelease];
	}
	cell.text = [appDelegate.recipes objectAtIndex:indexPath.row];
	cell.accessoryType = UITableViewCellAccessoryDisclosureIndicator;
	return cell;
}

- (NSInteger)tableView:(UITableView *)tv numberOfRowsInSection:(NSInteger)section {
	return [appDelegate.recipes count];
}

- (void)tableView:(UITableView *)tv didSelectRowAtIndexPath:(NSIndexPath *)indexPath {
	[appDelegate recipeClicked:[[tableView cellForRowAtIndexPath:indexPath] text]];
}

- (void)viewDidLoad {
	[super viewDidLoad];
	self.navigationItem.rightBarButtonItem = [[[UIBarButtonItem alloc] initWithBarButtonSystemItem:UIBarButtonSystemItemAdd target:self action:@selector(edit:)] autorelease];
}

- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation {
	// Return YES for supported orientations
	return (interfaceOrientation == UIInterfaceOrientationPortrait);
}


- (void)didReceiveMemoryWarning {
	[super didReceiveMemoryWarning]; // Releases the view if it doesn't have a superview
	// Release anything that's not essential, such as cached data
}


- (void)dealloc {
	[super dealloc];
}

@end
